<?php
abstract class Loader {
  protected abstract function loadFiles();
  protected abstract function doSomething();
  public final function load() {
    $this->loadFiles();
    $this->doSomething();
  }
}
class BarLoader extends Loader {
  protected function loadFiles() {require_once 'BarInputStream.php';}
  protected function doSomething() {
    $bar = new BarInputStream();
    $bar->seek(1);
  }
}
class FooLoader extends Loader {
  protected function loadFiles() {require_once 'FooInputStream.php';}
  protected function doSomething() {
    $foo = new FooInputStream();
  }
}
$b = new BarLoader();
$b->load();
$f = new FooLoader();
$f->load();
?>